/* makesaus.c -- sausage file packer
   by Brennan Underwood, http://brennan.home.ml.org/ */
#include <io.h>
#include <stdio.h>
#include <sys/stat.h>
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>

/* warning: this is a hacked up bit o crud. sorry. */

#include "sauspriv.h"

sausage_header header;
/* cheesy fixed limit, sorry */
sausage_file_entry ndex[4096];
char *fn[4096];

int main(int argc, char *argv[]) {
  int count = 0, ifd, ofd, i;
  char filename[20];
  void *item;
  struct stat sb;
  char *pt;

  if (argc < 2) {
    fprintf(stderr, "Usage:\n\tmakesaus sausfile.sau {file1 file2 file3 ...}\n"
                    "You can use @filelists too.\n");
    exit(0);
  }
  fprintf(stderr, "opening %s\n", argv[1]);
  ofd = open(argv[1], O_WRONLY | O_BINARY | O_CREAT | O_TRUNC, S_IWUSR);
  if (ofd < 0) {
    fprintf(stderr, "can't open %s\n", argv[1]);
    exit(0);
  }

  memset(&header, 0, sizeof header);
  memcpy(header.signature, "sausage", 7);
  header.signature[7] = 0x1a;
  header.version = SAUSAGE_VERSION;
fprintf(stderr, "Version: %x\n", SAUSAGE_VERSION);
  header.num_files = 0xc0edb00b;
  write(ofd, &header, sizeof header);

  /* write preliminary index */
  for (i = 2; i < argc; i++) {
    char *p;
    if (stat(argv[i], &sb)) {
      fprintf(stderr, "WARNING: %s not found\n", argv[i]);
      continue;
    }
    if (S_ISDIR(sb.st_mode)) {
      fprintf(stderr, "%s is a directory\n", argv[i]);
      continue;
    }
    fn[count] = strdup(argv[i]);
    for (p = fn[count]; *p; p++)
      if (*p == '\\') *p = '/';
    memset(ndex[count].filename, 0, FILENAMELEN);
    strcpy(ndex[count].filename, fn[count]);
    ndex[count].len = sb.st_size;
    ndex[count].offset = 0xdeaddead;
    fprintf(stderr, "writing prelim index entry for %s\n",ndex[count].filename);
    write(ofd, ndex + count, sizeof(sausage_file_entry));
    count++;
  }

  fprintf(stderr, "%d items\n", count);
  sleep(1);

  for (i = 0; i < count; i++) {
    if (fn[i] == NULL) break;
    if (strlen(fn[i]) > 80) {
      fprintf(stderr, "filename %s too long\n", fn[i]);
      exit(0);
    }
    if ((ifd = open(fn[i], O_RDONLY | O_BINARY)) < 0) {
      fprintf(stderr, "can't open %s\n", fn[i]);
      break;
    }
    fprintf(stderr, "reading %s (%d bytes): ", fn[i], ndex[i].len);
    ndex[i].offset = tell(ofd);
    item = (void *)malloc(ndex[i].len);
    if (item == NULL) {
      fprintf(stderr, "out of memory reading %s %d bytes\n", fn[i],
              ndex[i].len);
      exit(0);
    }
    if (read(ifd, item, ndex[i].len) != ndex[i].len) {
      fprintf(stderr, "error reading %s\n", fn[i]);
    }
    close(ifd);
    fprintf(stderr, "writing ");
    write(ofd, item, ndex[i].len);
    free(item);
    fprintf(stderr, "ok\n");
  }

  fprintf(stderr, "rewinding...\n");
  lseek(ofd, 0, SEEK_SET);
  header.num_files = count;
  write(ofd, &header, sizeof header);

  for (i = 0; i < count; i++) {
    if (fn[i] == NULL) {
      fprintf(stderr, "fn[%d] is null\n", i);
      exit(0);
    }
    fprintf(stderr, "writing index entry for %s: offset 0x%x\n",
            ndex[i].filename, ndex[i].offset);
    write(ofd, ndex + i, sizeof(sausage_file_entry));
  }

  /* update index */
  close(ofd);
  fprintf(stderr, "done: %d files written\n", count);
  exit(0);
}
