#ifndef _SAUSAGE_H
#define _SAUSAGE_H

#include <stdio.h>

typedef struct {
  FILE *fp;
  int start, end;
} SAUSAGE_FILE;

/* This is the only approved way to get the FILE* from a SAUSAGE_FILE*,
   if you absolutely must do it (i.e. to use MikMod's wave loader) */
#define SAUSAGE_FP(x) ((x)->fp)

int mount_sausage(char *filename, int *version);
int control_sausage(int control, int param);
enum { SAUS_OVERLAY, SAUS_OPEN_STANDALONE };

/* just like their stdio equivalents */
SAUSAGE_FILE *sausage_fopen(char *filename, char *mode);
void sausage_fclose(SAUSAGE_FILE *sfp);
int sausage_fread(void *buf, int size, int num, SAUSAGE_FILE *sfp);
char *sausage_fgets(char *buf, int len, SAUSAGE_FILE *sfp);
int sausage_fseek(SAUSAGE_FILE *sfp, int offset, int mode);
int sausage_ftell(SAUSAGE_FILE *sfp);

int sausage_read_int(SAUSAGE_FILE *sfp);
float sausage_read_float(SAUSAGE_FILE *sfp);

#ifndef SAUSLIB
/* mappings to convert stdio to sausage io */

#ifdef SAUSAGE_EASY_PORT

#define FILE SAUSAGE_FILE
#define fopen sausage_fopen
#define fclose sausage_fclose
#define fgets sausage_fgets
#define fseek sausage_fseek
#define fread sausage_fread
/* can't fwrite to sausage */
#define fwrite SAUSAGE_FILES_ARE_READ_ONLY

#endif
#endif

extern char *sausage_error;

#endif
